"""
Django settings for core project.

Generated by 'django-admin startproject' using Django 4.1.3.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

import logging
import os
from pathlib import Path

import dj_database_url
import sentry_sdk
from django.core.management.utils import get_random_secret_key
from dotenv import load_dotenv
from sentry_sdk.integrations.django import DjangoIntegration
from sentry_sdk.integrations.logging import LoggingIntegration

load_dotenv()

logger = logging.getLogger(__name__)

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('DJANGO_SECRET_KEY', get_random_secret_key())

# SECURITY WARNING: don't run with debug turned on in production!
RENDER = os.environ.get("RENDER")
DEBUG = False if RENDER else True

ALLOWED_HOSTS = [
    'localhost',
    '127.0.0.1',
    'delvin-main.onrender.com',
]

CSRF_TRUSTED_ORIGINS = [
    'https://*.delvin-main.onrender.com',
]

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django_extensions',
    "crispy_forms",
    "crispy_bootstrap5",
    'users.apps.UsersConfig',
    'rest_framework',
    'rest_framework.authtoken',
    'dashboard.apps.DashboardConfig',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',  # under security above anything else to serve static files.
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'core.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'core.wsgi.application'

# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

if RENDER:
    DATABASES = {
        'default': dj_database_url.config(default=os.environ.get('DJANGO_DATABASE_URL')),
        'supabase-db-test': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'HOST': os.environ.get('SUPABASE_DB_TEST'),
            'PASSWORD': os.environ.get('SUPABASE_PASSWORD_TEST'),
            'PORT': 5432,
            'USER': os.environ.get('SUPABASE_USER'),
        },
        'supabase-db-rori': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'HOST': os.environ.get('SUPABASE_DB_RORI'),
            'PASSWORD': os.environ.get('SUPABASE_PASSWORD_RORI'),
            'PORT': 5432,
            'USER': os.environ.get('SUPABASE_USER'),
        },
        'supabase-db-cc': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'HOST': os.environ.get('SUPABASE_DB_CC'),
            'PASSWORD': os.environ.get('SUPABASE_PASSWORD_CC'),
            'PORT': 5432,
            'USER': os.environ.get('SUPABASE_USER'),
        },
    }
else:
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': BASE_DIR / 'db.sqlite3',
        },
        # 'supabase-db-test': {
        #     'ENGINE': 'django.db.backends.postgresql',
        #     'NAME': 'postgres',
        #     'HOST': os.environ.get('SUPABASE_DB_TEST'),
        #     'PASSWORD': os.environ.get('SUPABASE_PASSWORD_TEST'),
        #     'PORT': 5432,
        #     'USER': os.environ.get('SUPABASE_USER'),
        # },
        'supabase-db-rori': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'HOST': os.environ.get('SUPABASE_DB_RORI'),
            'PASSWORD': os.environ.get('SUPABASE_PASSWORD_RORI'),
            'PORT': 5432,
            'USER': os.environ.get('SUPABASE_USER'),
        },
        'supabase-db-cc': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'postgres',
            'HOST': os.environ.get('SUPABASE_DB_CC'),
            'PASSWORD': os.environ.get('SUPABASE_PASSWORD_CC'),
            'PORT': 5432,
            'USER': os.environ.get('SUPABASE_USER'),
        },
    }


DATABASE_ROUTERS = ('dashboard.dbrouters.DashboardDBRouter',)

# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': [
        'rest_framework.authentication.TokenAuthentication',
    ],
}

# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/
# https://codinggear.blog/django-static-files-and-django-collectstatic/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles')

MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

STATICFILES_DIRS = (
    os.path.join(BASE_DIR, 'static'),
)

STATICFILES_STORAGE = "whitenoise.storage.CompressedManifestStaticFilesStorage"

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

CRISPY_ALLOWED_TEMPLATE_PACKS = "bootstrap5"

CRISPY_TEMPLATE_PACK = "bootstrap5"

LOGIN_REDIRECT_URL = '/'
LOGIN_URL = "login"

SENTRY_DSN = os.environ.get("SENTRY_DSN")

if SENTRY_DSN:
    sentry_sdk.init(
        dsn=SENTRY_DSN,
        integrations=[
            DjangoIntegration(),
            LoggingIntegration(
                level=logging.INFO,  # Capture info and above as breadcrumbs
                event_level=logging.ERROR  # Send python log.error messages as Sentry "events"
            ),
        ],
        # Set traces_sample_rate to 1.0 = capture 100% of transactions for performance monitoring.
        traces_sample_rate=1.0,
        send_default_pii=True
    )

    logger.info(f"dsn={SENTRY_DSN}. starting up {__file__}")
